﻿using Syncfusion.Drawing;
using Syncfusion.Pdf;
using Syncfusion.Pdf.Graphics;
using Syncfusion.Pdf.Parsing;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.IO;
using System.Linq;
using System.Reflection;
using System.Text;
using System.Threading.Tasks;

using Xamarin.Forms;
using Xamarin.Forms.Xaml;
using Syncfusion.SfChart.XForms;

namespace ImageDrawing
{
    [XamlCompilation(XamlCompilationOptions.Compile)]
    public partial class TabbedPage1 : TabbedPage
    {
        public TabbedPage1()
        {
            InitializeComponent();

            button.Clicked += Button_Clicked;
            NumericalStripLine stripLine = new NumericalStripLine()
            {

                Start = 42,
                Width = 200,
                Text = "Quarter-2",
                FillColor = Xamarin.Forms.Color.FromHex("#3FAA38"),
                IsSegmented = true,

                SegmentStart = new DateTime(2011, 02, 02),
                SegmentEnd = new DateTime(2012, 04, 05)

            };

            numericalAxis.StripLines.Add(stripLine);
            GeneratePDF.Clicked += GeneratePDF_Clicked;
        }

        private void Button_Clicked(object sender, EventArgs e)
        {
            SFChart.SaveAsImage("ChartImage.jpg");
        }

        private void GeneratePDF_Clicked(object sender, EventArgs e)
        {
            Stream chartStream = SFChart.GetStream();

            //Load the file as stream

            //Stream docStream = typeof(App).GetTypeInfo().Assembly.GetManifestResourceStream("ImageDrawing.Assets.Sample.pdf");

            //Load a PDF document.

            PdfDocument doc = new PdfDocument();


            //Get first page from document

            PdfPage page = doc.Pages.Add();

            doc.PageSettings.Height = 1000.0f;
            doc.PageSettings.Width = 1500.0f;


            //Create PDF graphics for the page

            PdfGraphics graphics = page.Graphics;


            //Draw the text


            //Load the image from the disk.


            //Draw the image


            graphics.DrawImage(PdfImage.FromStream(chartStream), 0, 20, page.GetClientSize().Width,
                   page.GetClientSize().Height);

            //graphics.DrawString("Giatec", new PdfStandardFont(PdfFontFamily.Helvetica, 10), PdfBrushes.Black, new PointF(20, 20));


            //Stream imageStream = DependencyService.Get<ISave>().ConvertPngToJpeg(DependencyService.Get<IRead>().ReadAsync("Test.png"));

            //PdfBitmap image = new PdfBitmap(imageStream);
            //Draw image


            //graphics.DrawImage(image, 10, 100, 400, 500);



            MemoryStream memoryStream = new MemoryStream();

            //Save the document into memory stream

            doc.Save(memoryStream);

            //close the documents

            doc.Close(true);


            //Save the stream into pdf file

            DependencyService.Get<ISave>().SaveAsync("sample.pdf", "application/pdf", memoryStream);
        }
    }


    public class ChartViewModel
    {
        public ObservableCollection<ChartDataPoint> HighTemperature { get; set; }

        public ChartViewModel()
        {
            HighTemperature = new ObservableCollection<ChartDataPoint>();

            HighTemperature.Add(new ChartDataPoint(new DateTime(2011, 02, 02, 2, 5, 2), 42));
            HighTemperature.Add(new ChartDataPoint(new DateTime(2012, 04, 05, 2, 5, 2), 44));
            HighTemperature.Add(new ChartDataPoint(new DateTime(2012, 05, 02, 2, 5, 2), 53));
            HighTemperature.Add(new ChartDataPoint(new DateTime(2013, 06, 02, 2, 5, 2), 64));
            HighTemperature.Add(new ChartDataPoint(new DateTime(2014, 07, 02, 2, 5, 2), 75));

        }
    }
}